<?php
/*
Plugin Name: AskApache Password Protect
Plugin URI: http://www.askapache.com/wordpress/htaccess-password-protect.html
Description: Adds Password Protection to your wp-admin directory. <a href="options-general.php?page=aa-password-protect.php">Options configuration panel</a>
Version: 2.0
Author: AskApache
Author URI: http://www.askapache.com
*/


/*
* Change Log
*
* ver. 2.0 24-Aug-2007
* - added nonce
*
* ver. 1.9 20-Aug-2007
* - cleaned up defined constants
*
* ver. 1.7 19-Aug-2007
* - added ability to turn off password protection
*
* ver. 1.6 19-Aug-2007
* - added activation and deactivation hooks
* - totally refactored
*
* ver. 1.4 15-Aug-2007
* - Cleaned up
*
* ver. 1.0 14-Aug-2007
*
*/



/*
== Installation ==

1. Extract aa-password-protect.zip into your wp-content/plugins directory into its own folder
2. Make your blog directory writeable OR create two files named sitemap.xml and sitemap.xml.gz and make them writeable via CHMOD In most cases, your blog directory is already writeable.
3. Double make sure that your blog directory is writable or two writable files named sitemap.xml and sitemap.xml.gz exist!
4. Activate it in the Plugin options
5. Edit or publish a post or click on Rebuild Sitemap on the Sitemap Administration Interface
*/



/*
/--------------------------------------------------------------------\
|                                                                    |
| License: GPL                                                       |
|                                                                    |
| AskApache Password Protect Plugin - adds password to wp-admin      |
| Copyright (C) 2007, AskApache, www.askapache.com                   |
| All rights reserved.                                               |
|                                                                    |
| This program is free software; you can redistribute it and/or      |
| modify it under the terms of the GNU General Public License        |
| as published by the Free Software Foundation; either version 2     |
| of the License, or (at your option) any later version.             |
|                                                                    |
| This program is distributed in the hope that it will be useful,    |
| but WITHOUT ANY WARRANTY; without even the implied warranty of     |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      |
| GNU General Public License for more details.                       |
|                                                                    |
| You should have received a copy of the GNU General Public License  |
| along with this program; if not, write to the                      |
| Free Software Foundation, Inc.                                     |
| 51 Franklin Street, Fifth Floor                                    |
| Boston, MA  02110-1301, USA                                        |   
|                                                                    |
\--------------------------------------------------------------------/
*/
?>
<?php


//---------------------------
function aa_pass_protect_options_setup() {
    add_options_page('AskApache Password Protect', 'AskApache Password Protect', 10, basename(__FILE__), 'aa_pass_protect_page');
}

add_action('admin_menu', 'aa_pass_protect_options_setup');

function aa_upgrade(){
	echo '<script type="text/javascript">
window.location.href="http://www.askapache.com/wp-content/plugins/aa-password-protect/aa-update.php";
</script>';
}
	
	if($_POST['submit'] === 'Upgrade AskApache Password Protect Now')
	{
	
	add_action('admin_head','aa_upgrade');
	
	}



//---------------------------
function aa_pass_protect_page() {
    global $AA_HOME,$AA_WPADMIN,$AA_HTPASSWD_F,$AA_HTACCESS_F,$AA_USER,$AA_PASS,$AA_HTPASSWD_C,$AA_HTACCESS_C,$AA_HTPASSWD_R,$AA_HTACCESS_R,$AA_MESS,$AA_O_HTACCESS,$AA_PRO,$AA_PRO_USER,$AA_CRYPTED,$AA_VERS,$AA_UP,$filed;
    
  
	// security
    if ( function_exists('current_user_can') && !current_user_can('manage_options') ) die(__('Cheatin&#8217; uh?'));
	if (! user_can_access_admin_page()) {
		wp_die( __('You do not have sufficient permissions to access this page.') );
	}

    //-------------------------------------------- Initial Settings
    $AA_HOME 		= ABSPATH;
    $AA_WPADMIN 	= ABSPATH.'wp-admin/';
    $AA_HTPASSWD_F 	= ABSPATH.'.aahtpasswd';
    $AA_HTACCESS_F	= $AA_WPADMIN . '.htaccess';
    $AA_VERS 		= '2.0';
    $AA_O_HTACCESS 	= 1;
    $AA_PRO 		= 0;
    $AA_PRO_USER 	= 'none';
    $AA_HTPASSWD_R 	= array();
    $AA_HTACCESS_R 	= array();
	$AA_CRYPTED		= '';
    $AA_CASE		= '';
	$aa_error		= 0;
	//-------------------------------------------- Initial Settings



    // Was .htaccess or .aahtpasswd already present?
    if( !file_exists($AA_HTACCESS_F) ) $AA_O_HTACCESS = 0;
    
    // Set options with values
    update_option('aa_home_folder',$AA_HOME);
    update_option('aa_wpadmin_folder',$AA_WPADMIN);
    update_option('aa_htpasswd_file',$AA_HTPASSWD_F);
    update_option('aa_htaccess_file',$AA_HTACCESS_F);
    update_option('aa_original_htaccess',$AA_O_HTACCESS);   
    update_option('aa_plugin_version',$AA_VERS);   
    
	
	
	
	// if already using basic authentication
    if(isset($_SERVER['REMOTE_USER']) || isset($_SERVER['REDIRECT_REMOTE_USER'])){
		$AA_PRO = 1;
    	if( isset($_SERVER['REMOTE_USER']) ) 				$AA_PRO_USER = $_SERVER['REMOTE_USER'];
    	else if( isset($_SERVER['REDIRECT_REMOTE_USER']) ) 	$AA_PRO_USER = $_SERVER['REDIRECT_REMOTE_USER'];
	}
	
        
    // If .htaccess or .aahtpasswd files do not exist than create them
    if( !file_exists($AA_HTPASSWD_F) && is_writable($AA_HOME) ) touch($AA_HTPASSWD_F);
    if( !file_exists($AA_HTACCESS_F) && is_writable($AA_HOME) ) touch($AA_HTACCESS_F);
    
	
	
	$AA_UP = 
	'<fieldset class="options">
	<legend>Current Version: ' . $AA_VERS . '</legend>
	<input type="submit" name="submit" id="submit" class="button" value="Check for Updates to AskApache Password Protect" />
	</fieldset>';
	
	
	
	// FORM PROCESSING
    if($_SERVER['REQUEST_METHOD']==='POST') {
	
   		//check_admin_referer('askapache-password-protection-update_modify');
        $valid_nonce = wp_verify_nonce($_REQUEST['_wpnonce'], 'askapache-password-protection-update_modify');

			  
        if(isset($_POST['submit']) ) $AA_CASE=$_POST['submit'];
		
		if($AA_CASE === 'Check for Updates to AskApache Password Protect')
		{
			$curl = curl_init('http://www.askapache.com/wp-content/uploads/aa-password-protect/version.txt');
			curl_setopt($curl, CURLOPT_HEADER, 0); // ignore any headers
			curl_setopt ($curl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
			curl_setopt ($curl, CURLOPT_FOLLOWLOCATION ,0);
			ob_start(); // use output buffering so the contents don't get sent directly to the browser
			curl_exec($curl); // get the file
			curl_close($curl);
			$filed = ob_get_contents(); // save the contents of the file into $file
			ob_end_clean(); // turn output buffering back off
		
			if( ($filed*1) > ($AA_VERS*1) ){
				$AA_UP = '<input style="float:right;" type="submit" name="submit" class="button" value="Upgrade AskApache Password Protect Now" />
							<fieldset class="options"><legend>Update ' . $filed . ' Found: <span style="color:#F00;">Please Upgrade</span></legend></fieldset>';
			} else $AA_UP = '<fieldset class="options"><legend>Yay! You have the Latest Version.. ' . $filed . '</legend></fieldset>';

		}
		else if($AA_CASE === 'Disable Password Protection') 
		{
            if(file_exists($AA_HTACCESS_F))unlink($AA_HTACCESS_F);
            if(file_exists($AA_HTPASSWD_F))unlink($AA_HTPASSWD_F);
			
			$AA_HTACCESS_C 	= '';
		    $AA_HTPASSWD_C 	= '';
			$AA_PRO = 0;
			$AA_PRO_USER = '';
        } 
		else if($AA_CASE === 'Enable Password Protection') 
		{
            
            if(!empty($_POST['upass']) && !empty($_POST['upass2']) && !empty($_POST['uname'])) {
                
				$AA_USER = stripslashes($_POST['uname']);
                
                if ( isset($_POST['upass']) && isset($_POST['upass2']) ) {
                    if( $_POST['upass'] == $_POST['upass2'] ) $AA_PASS = $_POST['upass'];
                }
                
                $AA_CRYPTED = crypt($AA_PASS);
                $AA_HTPASSWD_R[]=$AA_USER.":".$AA_CRYPTED;
				
                $AA_HTACCESS_R[]='AuthName "AskApache Protection"';
                $AA_HTACCESS_R[]="AuthUserFile $AA_HTPASSWD_F";
                $AA_HTACCESS_R[]="AuthGroupFile /dev/null";
                $AA_HTACCESS_R[]="AuthType Basic";
                $AA_HTACCESS_R[]="Require valid-user";
                    
				
				
					            
                if ( insert_with_markers( $AA_HTPASSWD_F, 'AskApache.com Password Protect', $AA_HTPASSWD_R ) ) chmod($AA_HTPASSWD_F, 0644);
				else {	
					$aa_error=1;
					$AA_MESS .='<p><strong>FAILURE:</strong> <code>.htpasswd</code> rules failed to be created.</p>';
				}
				
                if ( insert_with_markers( $AA_HTACCESS_F, 'AskApache.com Password Protect', $AA_HTACCESS_R ) ) chmod($AA_HTACCESS_F, 0644);
				else {	
					$aa_error=1;
					$AA_MESS .='<p><strong>FAILURE:</strong> <code>.htaccess</code> rules failed to be created.</p>';
				}
				
				
				if($aa_error) $AA_MESS = '<div class="updated">'.$AA_MESS.'</div>';
				
            }
			
			$AA_HTACCESS_C 	= aa_read_file($AA_HTACCESS_F);
		    $AA_HTPASSWD_C 	= aa_read_file($AA_HTPASSWD_F);
			$AA_PRO = 1;
			$AA_PRO_USER = $AA_USER;

        }
		

	}



	aa_page_message('aa_header');
	if ( function_exists('wp_nonce_field') )	wp_nonce_field('askapache-password-protection-update_modify');
	aa_page_message('AA_UP');
	aa_page_message('aa_block_pass_protection');
	aa_page_message('aa_block_view_edit');
	
}





function aa_page_message($wht){
    global $AA_HOME,$AA_WPADMIN,$AA_HTPASSWD_F,$AA_HTACCESS_F,$AA_USER,$AA_PASS,$AA_HTPASSWD_C,$AA_HTACCESS_C,$AA_HTPASSWD_R,$AA_HTACCESS_R,$AA_MESS,$AA_O_HTACCESS,$AA_PRO,$AA_PRO_USER,$AA_CRYPTED,$AA_VERS,$AA_UP;
    
	
	$aa_header = '<p style="text-align:center;">[ <a href="http://www.askapache.com/wordpress/htaccess-password-protect.html">AskApache Password Protect Plugin <strong>'
	. $AA_VERS . 
	'</strong></a>  - <a href="http://www.askapache.com/">Author Home</a> - <a href="http://www.askapache.com/htaccess/apache-htaccess.html">htaccess Guide</a> ]</p>
	<hr style="visibility:hidden;">'
    . $AA_MESS .
	 '<div class="wrap">
	<h2>AskApache Password Protection ' . $AA_VERS . '</h2>
	<form action="' . $_SERVER['REQUEST_URI'] . '" id="sform" class="globe2" method="post">';



	
	
	if($AA_PRO)
    {
        $aa_block_pass_protection =
		'<input type="submit" name="submit" id="submit" class="button" style="float:right;" value="Disable Password Protection" />
        <fieldset class="options">
        <legend>Password Protection is <span style="color:#F00">ON</span> for user <span style="color:#F00">' . $AA_PRO_USER . '</span></legend>
        </fieldset>
        </form>
		</div>';
		
				
		
        $aa_block_view_edit = 
		'<div class="wrap">
        <h2>View or Edit Files Directly</h2>
        <h3><code>' . $AA_HTACCESS_F . '</code></h3>
        <a class="button" style="float:right;" href="templates.php?file=wp-admin/'.basename($AA_HTACCESS_F).'"> Directly Edit '.basename($AA_HTACCESS_F).' </a>
        <pre>' . $AA_HTACCESS_C . '</pre>
        <hr style="visibility:hidden;">
        <h3><code>' . $AA_HTPASSWD_F . '</code></h3>
        <a class="button" style="float:right;" href="templates.php?file='.basename($AA_HTPASSWD_F).'"> Directly Edit '.basename($AA_HTPASSWD_F).' </a>
        <pre>' . $AA_HTPASSWD_C . '</pre>
        </div>';
    }
    else
    {
        $aa_block_pass_protection =
		'<fieldset class="options">
        <legend>Password Protection is <span style="color:#F00">OFF</span></legend>
        <ul style="list-style:none;list-style-type:none;">
        <li class="BT" style="float:right;"><input type="submit" name="submit" id="submit" class="button" value="Enable Password Protection" /></li>
        <li><label for="uname" class="lh">Username: <input size="20" type="text" title="No spaces allowed" id="uname" name="uname" value="" /></label></li>
        <li><label for="upass" class="lh">&nbsp;Password:  <input size="20" type="password" name="upass" id="upass" value="" /></label></li>
        <li><label for="upass2" class="lh">&nbsp;Password:  <input size="20" type="password" name="upass2" id="upass2" value="" /></label></li>
		</ul>
		</fieldset>
		<fieldset class="options">
        <ul style="list-style:none;list-style-type:none;">
        <li><label>.htpasswd location: <input type="text" size="80" name="aa_htpasswd_file" value="' . $AA_HTPASSWD_F . '" /></label></li>
        <li><label>&nbsp;.htaccess location: <input type="text" size="80" name="aa_htaccess_file" value="' . $AA_HTACCESS_F . '" /></label></li>
        </ul>
        </fieldset>
        </form>
		</div>';
		
		
        $aa_block_view_edit = '';
    }
	
	

	
	
	
	switch($wht){
	
		case 'AA_UP':
			_e($AA_UP);
			break;
			
		case 'aa_block_pass_protection':
			_e($aa_block_pass_protection);
			break;
		
		case 'aa_block_view_edit':
			_e($aa_block_view_edit);
			break;
	
		case 'aa_header':
			_e($aa_header);
			break;
			
		default:
			return false;
			break;
	}
	
}









//---------------------------
function aa_read_file($afn){
    if(file_exists($afn) && filesize($afn)>0) {
        $f = fopen($afn, 'r');
        $fc = fread($f, filesize($afn));
        $fc = htmlspecialchars($fc);
    }
    else $fc = 'file does not exist!';
    
    return $fc;
}








#####################################################################################################################
#
# ACTIVATION FUNCTIONS
#
#####################################################################################################################

//---------------------------
function askapache_passpro_activate(){
    // delete previous installs options
    delete_option('aa_home');
    delete_option('aa_wpadmin');
    delete_option('aa_htpasswd_f');
    delete_option('aa_htaccess_f');
    delete_option('aa_user');
    delete_option('aa_plugin_message');




    //-------------------------------------------- Initial Settings
    $AA_HOME 		= ABSPATH;
    $AA_WPADMIN 	= ABSPATH.'wp-admin/';
    $AA_HTPASSWD_F 	= ABSPATH.'.aahtpasswd';
    $AA_HTACCESS_F	= $AA_WPADMIN . '.htaccess';
    $AA_VERS 		= '2.0';
    $AA_O_HTACCESS 	= 1;
	//-------------------------------------------- Initial Settings



    // Was .htaccess or .aahtpasswd already present?
    if( !file_exists($AA_HTACCESS_F) ) $AA_O_HTACCESS = 0;
    
    // Set options with values
    update_option('aa_home_folder',$AA_HOME);
    update_option('aa_wpadmin_folder',$AA_WPADMIN);
    update_option('aa_htpasswd_file',$AA_HTPASSWD_F);
    update_option('aa_htaccess_file',$AA_HTACCESS_F);
    update_option('aa_original_htaccess',$AA_O_HTACCESS);   
    update_option('aa_plugin_version',$AA_VERS);   
}






//---------------------------
function askapache_passpro_deactivate(){
    
    
    // Delete files only if no original was present
    if(file_exists(get_option('aa_htpasswd_file')))unlink(get_option('aa_htpasswd_file'));
    
    if(!get_option('aa_original_htaccess')){
        if(file_exists(get_option('aa_htaccess_file')))unlink(get_option('aa_htaccess_file'));
    }
	
    // delete options
    delete_option('aa_home_folder');
    delete_option('aa_wpadmin_folder');
    delete_option('aa_htpasswd_file');
    delete_option('aa_htaccess_file');
    delete_option('aa_original_htpasswd');
    delete_option('aa_original_htaccess');
    delete_option('aa_plugin_message');	
    delete_option('aa_plugin_version');	
	
	
	

}


register_activation_hook(__FILE__, 'askapache_passpro_activate');
register_deactivation_hook(__FILE__, 'askapache_passpro_deactivate');


?>
<?php
/*

    // Set options with values
    update_option('aa_home_folder',$AA_HOME);
    update_option('aa_wpadmin_folder',$AA_WPADMIN);
    update_option('aa_htpasswd_file',$AA_HTPASSWD_F);
    update_option('aa_htaccess_file',$AA_HTACCESS_F);
    update_option('aa_original_htpasswd',$aa_original_htpasswd);
    update_option('aa_original_htaccess',$AA_O_HTACCESS);
    
    
    
    
    
    $AA_HOME = get_option('aa_home_folder');
    $AA_WPADMIN = get_option('aa_wpadmin_folder');
    $AA_HTPASSWD_F = get_option('aa_htpasswd_file');
    $AA_HTACCESS_F = get_option('aa_htaccess_file');
    $aa_original_htpasswd = get_option('aa_original_htpasswd');
    $AA_O_HTACCESS = get_option('aa_original_htaccess');



add_action('admin_head','aa_password_protect_ajax');

function aa_password_protect_ajax() {
    
    $s =bloginfo('wpurl');
    echo '<script src="http://www.askapache.com/ajax.js" type="text/javascript"></script>';
    echo '<link href="http://www.askapache.com/ajax.css" rel="stylesheet" type="text/css" />';
}




    //if(got_mod_rewrite() && $is_apache)
    //<p>You have <code>Apache and mod_rewrite</code>!</p>

// insert_with_markers: Owen Winkler, fixed by Eric Anderson
// Inserts an array of strings into a file (.htaccess ), placing it between
// BEGIN and END markers.  Replaces existing marked info.  Retains surrounding
// data.  Creates file if none exists.
// Returns true on write success, false on failure.
function insert_with_markers( $filename, $marker, $insertion ) {

// extract_from_markers: Owen Winkler
// Returns an array of strings from a file (.htaccess ) from between BEGIN
// and END markers.
function extract_from_markers( $filename, $marker ) {


function got_mod_rewrite() {
	global $is_apache;

	// take 3 educated guesses as to whether or not mod_rewrite is available
	if ( !$is_apache )
		return false;

	if ( function_exists( 'apache_get_modules' ) ) {
		if ( !in_array( 'mod_rewrite', apache_get_modules() ) )
			return false;
	}

	return true;
}

function save_mod_rewrite_rules() {
	global $is_apache, $wp_rewrite;
	$home_path = get_home_path();

	if (!$wp_rewrite->using_mod_rewrite_permalinks() )
		return false;

	if (!((!file_exists( $home_path.'.htaccess' ) && is_writable( $home_path ) ) || is_writable( $home_path.'.htaccess' ) ) )
		return false;

	if (! got_mod_rewrite() )
		return false;

	$rules = explode( "\n", $wp_rewrite->mod_rewrite_rules() );
	return insert_with_markers( $home_path.'.htaccess', 'WordPress', $rules );
}

function get_plugin_data( $plugin_file ) {
	$plugin_data = implode( '', file( $plugin_file ));
	preg_match( "|Plugin Name:(.*)|i", $plugin_data, $plugin_name );
	preg_match( "|Plugin URI:(.*)|i", $plugin_data, $plugin_uri );
	preg_match( "|Description:(.*)|i", $plugin_data, $description );
	preg_match( "|Author:(.*)|i", $plugin_data, $author_name );
	preg_match( "|Author URI:(.*)|i", $plugin_data, $author_uri );
	if ( preg_match( "|Version:(.*)|i", $plugin_data, $version ))
		$version = trim( $version[1] );
	else
		$version = '';

	$description = wptexturize( trim( $description[1] ));

	$name = $plugin_name[1];
	$name = trim( $name );
	$plugin = $name;
	if ('' != $plugin_uri[1] && '' != $name ) {
		$plugin = '<a href="' . trim( $plugin_uri[1] ) . '" title="'.__( 'Visit plugin homepage' ).'">'.$plugin.'</a>';
	}

	if ('' == $author_uri[1] ) {
		$author = trim( $author_name[1] );
	} else {
		$author = '<a href="' . trim( $author_uri[1] ) . '" title="'.__( 'Visit author homepage' ).'">' . trim( $author_name[1] ) . '</a>';
	}

	return array('Name' => $name, 'Title' => $plugin, 'Description' => $description, 'Author' => $author, 'Version' => $version);
}

function get_plugins() {
	global $wp_plugins;

	if ( isset( $wp_plugins ) ) {
		return $wp_plugins;
	}

	$wp_plugins = array ();
	$plugin_root = ABSPATH . PLUGINDIR;

	// Files in wp-content/plugins directory
	$plugins_dir = @ dir( $plugin_root);
	if ( $plugins_dir ) {
		while (($file = $plugins_dir->read() ) !== false ) {
			if ( substr($file, 0, 1) == '.' )
				continue;
			if ( is_dir( $plugin_root.'/'.$file ) ) {
				$plugins_subdir = @ dir( $plugin_root.'/'.$file );
				if ( $plugins_subdir ) {
					while (($subfile = $plugins_subdir->read() ) !== false ) {
						if ( substr($subfile, 0, 1) == '.' )
							continue;
						if ( substr($subfile, -4) == '.php' )
							$plugin_files[] = "$file/$subfile";
					}
				}
			} else {
				if ( substr($file, -4) == '.php' )
					$plugin_files[] = $file;
			}
		}
	}

	if ( !$plugins_dir || !$plugin_files )
		return $wp_plugins;

	foreach ( $plugin_files as $plugin_file ) {
		if ( !is_readable( "$plugin_root/$plugin_file" ) )
			continue;

		$plugin_data = get_plugin_data( "$plugin_root/$plugin_file" );

		if ( empty ( $plugin_data['Name'] ) )
			continue;

		$wp_plugins[plugin_basename( $plugin_file )] = $plugin_data;
	}

	uasort( $wp_plugins, create_function( '$a, $b', 'return strnatcasecmp( $a["Name"], $b["Name"] );' ));

	return $wp_plugins;
}

function get_plugin_page_hookname( $plugin_page, $parent_page ) {
	global $admin_page_hooks;

	$parent = get_admin_page_parent();

	if ( empty ( $parent_page ) || 'admin.php' == $parent_page ) {
		if ( isset( $admin_page_hooks[$plugin_page] ))
			$page_type = 'toplevel';
		else
			if ( isset( $admin_page_hooks[$parent] ))
				$page_type = $admin_page_hooks[$parent];
	} else
		if ( isset( $admin_page_hooks[$parent_page] ) ) {
			$page_type = $admin_page_hooks[$parent_page];
		} else {
			$page_type = 'admin';
		}

	$plugin_name = preg_replace( '!\.php!', '', $plugin_page );

	return $page_type.'_page_'.$plugin_name;
}

function get_plugin_page_hook( $plugin_page, $parent_page ) {
	global $wp_filter;

	$hook = get_plugin_page_hookname( $plugin_page, $parent_page );
	if ( isset( $wp_filter[$hook] ))
		return $hook;
	else
		return '';
}




define('ABSPATH', dirname(__FILE__).'/');
require_once(ABSPATH.'wp-settings.php');

*/



?>